{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}

    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //Client:{routeName:'BaseController-getComboValues',table:'clients'}
            //,ClientG:{routeName:'BaseController-getComboValues',table:'clients'/*,options:{where:'O'}*/}
            ProductTree:{routeName:'ProductTree-getComboValues-special',table:'product_trees',options:{where:'M',finish:null}}
        },
        _onButtonSaveAsXLSClick:function(){
            var t = this;
            if (t.modulename && typeof Routing !== 'undefined') {
                t.waitMaskShow();
                var routeName = 'Reports-add';
                var route = Routing.getRoute(routeName);
                var pagerParams = {'pg':1,'lm':25};
                var url = Routing.generate(routeName, pagerParams);
                if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                    $.ajax({
                        url: url,
                        method: "POST",
                        headers: { 
                            "Content-Type": "application/json",
                            "X-HTTP-Method-Override": route.methods[0] 
                        },
                        data: JSON.stringify({reportname:'KanbanOperationAll'}),
                        dataType: 'binary',
                        processData: false,
                        success: function(data, textStatus, xhr) {
                            //t.activateTabGrid();
                            if(textStatus==='success'){
                                var filename = "";
                                var disposition = xhr.getResponseHeader('Content-Disposition');
                                if (disposition && disposition.indexOf('attachment') !== -1) {
                                    var filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
                                    var matches = filenameRegex.exec(disposition);
                                    if (matches != null && matches[1]) filename = matches[1].replace(/['"]/g, '');
                                }
                                var type = xhr.getResponseHeader('Content-Type');
                                var blob = typeof File === 'function'
                                    ? new File([data], filename, { type: type })
                                    : new Blob([data], { type: type });
                                if (typeof window.navigator.msSaveBlob !== 'undefined') {
                                    // IE workaround for "HTML7007: One or more blob URLs were revoked by closing the blob for which they were created. These URLs will no longer resolve as the data backing the URL has been freed."
                                    window.navigator.msSaveBlob(blob, filename);
                                    t.waitMaskHide();
                                } else {
                                    var URL = window.URL || window.webkitURL;
                                    var downloadUrl = URL.createObjectURL(blob);
                                    if (filename) {
                                        // use HTML5 a[download] attribute to specify filename
                                        var a = document.createElement("a");
                                        // safari doesn't support this yet
                                        if (typeof a.download === 'undefined') {
                                            window.location = downloadUrl;
                                            t.waitMaskHide();
                                        } else {
                                            a.href = downloadUrl;
                                            a.download = filename;
                                            document.body.appendChild(a);
                                            a.click();
                                            t.waitMaskHide();
                                        }
                                    } else {
                                        window.location = downloadUrl;
                                        t.waitMaskHide();
                                    }

                                    setTimeout(function () { URL.revokeObjectURL(downloadUrl); }, 100); // cleanup
                                }
                            }
                        },
                        error: function(xhr, textStatus, errorThrown) {
                            t.waitMaskHide();
                            if(xhr.responseJSON&&xhr.responseJSON.message){
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: xhr.responseJSON.message,
                                    type: "error",
                                    html: true
                                });
                            }
                        },
                        complete: function(jqXHR, textStatus) {
                            t.waitMaskHide();
                        }
                    });
                }
            }
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons.saveAsCopy=true;
            const gridConfig = {
                cm: [
                    {header: "{{ 'KanbanOperation.client'|trans }}", dataIndex: 'client', width: 100,filter:'single', type:'combo',store:t.extras.clients,alias:'ko',operator:'='},
                    {header: "{{ 'KanbanOperation.product'|trans }}", dataIndex: 'product', width: 100,filter:'between',alias:'ko'},
                    {header: "{{ 'KanbanOperation.boxcount'|trans }}", dataIndex: 'boxcount', width: 80},
                    {header: "{{ 'KanbanOperation.minboxcount'|trans }}", dataIndex: 'minboxcount', width: 80},
                    {header: "{{ 'KanbanOperation.maxboxcount'|trans }}", dataIndex: 'maxboxcount', width: 80},
                    {header: "{{ 'KanbanOperation.currentboxcount'|trans }}", dataIndex: 'currentboxcount', width: 80},
                    {header: "{{ 'KanbanOperation.packaging'|trans }}", dataIndex: 'packaging', width: 80},
                    {header: "{{ 'KanbanOperation.hourlydemand'|trans }}", dataIndex: 'hourlydemand', width: 80}
                ]
            }
            t._setGridConfig(gridConfig);
            var _customer=(window.location.href.indexOf('1.40')>-1||window.location.href.indexOf('.149')-1)?'ermetal':'other';
            const formConfig = {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.combo({
                        title: "{{ 'KanbanOperation.client'|trans }}",
                        placeHolder: "{{ 'KanbanOperation.client_placeholder'|trans }}",
                        dataIndex: 'client',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        notEmpty: true,
                        grid: 's12 m6',
                        store: t.extras.clients
                    }),
                    new mj.form.combo({
                        title: "{{ 'KanbanOperation.product'|trans }}",
                        placeHolder: "{{ 'KanbanOperation.product_placeholder'|trans }}",
                        dataIndex: 'product',
                        mode: 'remote',
                        clearOnTriggerClick: true,
                        notEmpty: true,
                        right: true,
                        grid: 's12 m6',
                        store: t.stores.ProductTree
                    }),
                    new mj.form.numberField({
                        title: "{{ 'KanbanOperation.boxcount'|trans }}",
                        dataIndex: 'boxcount',
                        maxLength: 100,
                        notEmpty: true,
                        disabled:(_customer=='ermetal'),
                        grid: 's12 m6'
                    }),
                    new mj.form.numberField({
                        title: "{{ 'KanbanOperation.minboxcount'|trans }}",
                        dataIndex: 'minboxcount',
                        maxLength: 100,
                        notEmpty: true,
                        disabled:(_customer=='ermetal'),
                        grid: 's12 m6'
                    }),
                    new mj.form.numberField({
                        title: "{{ 'KanbanOperation.maxboxcount'|trans }}",
                        dataIndex: 'maxboxcount',
                        maxLength: 100,
                        notEmpty: true,
                        disabled:(_customer=='ermetal'),
                        grid: 's12 m6'
                    }),
                    new mj.form.numberField({
                        title: "{{ 'KanbanOperation.currentboxcount'|trans }}",
                        dataIndex: 'currentboxcount',
                        maxLength: 100,
                        disabled: true,
                        grid: 's12 m6'
                    }),
                    new mj.form.numberField({
                        title: "{{ 'KanbanOperation.packaging'|trans }}",
                        dataIndex: 'packaging',
                        maxLength: 100,
                        notEmpty: true,
                        disabled:(_customer=='ermetal'),
                        grid: 's12 m6'
                    }),
                    new mj.form.numberField({
                        title: "{{ 'KanbanOperation.hourlydemand'|trans }}",
                        dataIndex: 'hourlydemand',
                        maxLength: 100,
                        notEmpty: true,
                        disabled:(_customer=='ermetal'),
                        grid: 's12 m6'
                    })
                ]
            };
            t._setFormConfig(formConfig);

            if(typeof t.grids.main.pbar.tbar.addSplitter==='function'){
				t.grids.main.pbar.tbar.addSplitter();
			}
            t.buttons.saveAsXLS = t.grids.main.pbar.tbar.addButton({
                alt: mj.lng.glb.saveAsXLS,
                cls: 'btn-sm left',
                iconCls: 'mj-save-as-xls',
                scope: t,
                handler: t._onButtonSaveAsXLSClick
			});
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
